﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Priprema
{
    internal class Program
    {
        static void Main(string[] args)
        {
            try
            {
                PersonManager personManager = new PersonManager();
                personManager.OnLoad += PersonManager_OnLoad;
                personManager.OnError += PersonManager_OnError;
                IDictionary<string, Person> persons = personManager.Persons;
            }
            catch (Exception ex) {
                Show(ex.Message, ConsoleColor.Red);
            }
        }

        private static void PersonManager_OnError(object sender, OnErrorArgs args)
        {
            Show(args.Exception.Message, ConsoleColor.Red);
        }

        private static void PersonManager_OnLoad(object sender, OnLoadArgs args)
        {
            if (args.Missing.Count == 0) {
                Show(args.Person.ToString(), ConsoleColor.Green);
            }
            else
            {
                string report = string.Join(", ", args.Missing);
                Show(report, ConsoleColor.Yellow);
            }
        }

        public static void Show(string message, ConsoleColor color) {
            Console.ForegroundColor = color;
            Console.WriteLine(message);
            Console.ResetColor();
        }
    }
}
